
#include "stdafx.h"
#include "cddata.h"

#include <mmsystem.h>


//
// Information about the CD drives in the system
//

#ifndef MAKE_DWORD
#define MAKE_DWORD(lo,hi) ((DWORD)(((hi)<<16)|(lo)))
#endif

void WinNTFillDriveInfo(drv_info &drv)
{
    CString ddev = drv.path;
    ddev.TrimRight(_T('\\'));

    CString ntpath;
    QueryDosDevice(ddev, ntpath.GetBuffer(MAX_PATH), MAX_PATH);
    ntpath.ReleaseBuffer();

    CString ntdev = ntpath.Mid(ntpath.ReverseFind(_T('\\'))+1);
    drv.devname = ntdev;

    CRegKey scsimap;
    scsimap.Open(HKEY_LOCAL_MACHINE, _T("HARDWARE\\DEVICEMAP\\Scsi"), KEY_READ);

    TCHAR portbuf[512];
    DWORD cbportbuf;
    DWORD portidx = 0;
    LONG rv = ERROR_SUCCESS;
    bool bFound = false;

    while (!bFound && (rv=RegEnumKeyEx(scsimap, portidx, portbuf, &(cbportbuf=512), NULL, NULL, NULL, NULL))==ERROR_SUCCESS) {
        if (_tcsnicmp(portbuf, _T("Scsi Port "), 9)==0) {
            DWORD portnum;
            _stscanf(portbuf+10, _T("%d"), &portnum);

            CRegKey scsiport;
            scsiport.Open(scsimap, portbuf, KEY_READ);

            TCHAR busbuf[512];
            DWORD cbbusbuf;
            DWORD busidx = 0;

            while (!bFound && (rv=RegEnumKeyEx(scsiport, busidx, busbuf, &(cbbusbuf=512), NULL, NULL, NULL, NULL))==ERROR_SUCCESS) {
                if (_tcsnicmp(busbuf, _T("Scsi Bus "), 8)==0) {
                    DWORD busnum;
                    _stscanf(busbuf+9, _T("%d"), &busnum);

                    CRegKey scsibus;
                    scsibus.Open(scsiport, busbuf, KEY_READ);

                    TCHAR targbuf[512];
                    DWORD cbtargbuf;
                    DWORD targidx = 0;

                    while (!bFound && (rv=RegEnumKeyEx(scsibus, targidx, targbuf, &(cbtargbuf=512), NULL, NULL, NULL, NULL))==ERROR_SUCCESS) {
                        if (_tcsnicmp(targbuf, _T("Target Id "), 9)==0) {
                            DWORD targnum;
                            _stscanf(targbuf+10, _T("%d"), &targnum);

                            CRegKey scsitarg;
                            scsitarg.Open(scsibus, targbuf, KEY_READ);

                            TCHAR lunbuf[512];
                            DWORD cblunbuf;
                            DWORD lunidx = 0;

                            while (!bFound && (rv=RegEnumKeyEx(scsitarg, lunidx, lunbuf, &(cblunbuf=512), NULL, NULL, NULL, NULL))==ERROR_SUCCESS) {
                                if (_tcsnicmp(lunbuf, _T("Logical Unit Id "), 15)==0) {
                                    DWORD lunnum;
                                    _stscanf(lunbuf+16, _T("%d"), &lunnum);

                                    CRegKey scsilun;
                                    scsilun.Open(scsitarg, lunbuf, KEY_READ);

                                    CString t;
                                    DWORD cbt;
                                    scsilun.QueryValue(t.GetBuffer(MAX_PATH), _T("DeviceName"), &(cbt=MAX_PATH));
                                    t.ReleaseBuffer();

                                    if (t==ntdev) {
                                        drv.scsi_port = portnum;
                                        drv.scsi_bus = busnum;
                                        drv.scsi_targ = targnum;
                                        drv.scsi_lun = lunnum;
                                        scsilun.QueryValue(drv.name.GetBuffer(512), _T("Identifier"), &(cbt=512));
                                        drv.name.ReleaseBuffer();
                                        bFound = true;
                                    }
                                }
                                lunidx++;
                            }
                        }
                        targidx++;
                    }
                }
                busidx++;
            }
        }
        portidx++;
    }
}

void Win9XFillDriveInfo(drv_info &drv)
{
    CRegKey cmgr;
    cmgr.Open(HKEY_DYN_DATA, _T("Config Manager\\Enum"), KEY_READ);

    TCHAR cfbuf[512];
    DWORD cbcfbuf;
    DWORD cfidx = 0;
    LONG rv = ERROR_SUCCESS;
    bool bFound = false;

    while (!bFound && (rv=RegEnumKeyEx(cmgr, cfidx, cfbuf, &(cbcfbuf=512), NULL, NULL, NULL, NULL))==ERROR_SUCCESS) {
        CRegKey cf;
        cf.Open(cmgr, cfbuf, KEY_READ);

        CString hwbuf;
        DWORD cb;
        cf.QueryValue(hwbuf.GetBuffer(512), _T("HardWareKey"), &(cb=512));
        hwbuf.ReleaseBuffer();

        if (_tcsnicmp(hwbuf, _T("SCSI\\*"), 5)==0) {
            CString t;
            t.Format(_T("Enum\\%s"), (LPCTSTR)hwbuf);

            CRegKey hwk;
            hwk.Open(HKEY_LOCAL_MACHINE, t, KEY_READ);

            CString curdrv;
            hwk.QueryValue(curdrv.GetBuffer(16), _T("CurrentDriveLetterAssignment"), &(cb=16));
            curdrv.ReleaseBuffer();

            if (_totupper(curdrv.GetAt(0))==_totupper(drv.path.GetAt(0))) {
                CString targ;
                hwk.QueryValue(targ.GetBuffer(16), _T("SCSITargetID"), &(cb=16));
                targ.ReleaseBuffer();
                _stscanf((LPCTSTR)targ, _T("%d"), &drv.scsi_targ);

                CString lun;
                hwk.QueryValue(lun.GetBuffer(16), _T("SCSILUN"), &(cb=16));
                lun.ReleaseBuffer();
                _stscanf((LPCTSTR)lun, _T("%d"), &drv.scsi_lun);

                // Well, there's probably a way of getting Port/Bus number too
                // but I can't see it right now.

                CString desc;
                hwk.QueryValue(desc.GetBuffer(512), _T("DeviceDesc"), &(cb=512));
                desc.ReleaseBuffer();
                desc.TrimRight(_T(' '));
                drv.name = desc;

                bFound = true;
            }
        }
        cfidx++;
    }
}

void FillDriveInfo(drv_info &drv)
{
    if (isNT) {
        WinNTFillDriveInfo(drv);
    } else {
        Win9XFillDriveInfo(drv);
    }
}

CCDDrives::CCDDrives()
{
    DWORD dwLen = GetLogicalDriveStrings(0, NULL);

    LPTSTR drvs = (LPTSTR)alloca(sizeof(TCHAR)*(dwLen+2));
    GetLogicalDriveStrings(dwLen, drvs);

    m_drives.clear();
    int i=0;

    LPTSTR p = drvs;
    while (*p!=_T('\0')) {
        if (GetDriveType(p)==DRIVE_CDROM) {
            drv_info t;
            t.idx = i;
            t.path = p;
            FillDriveInfo(t);
            m_drives.push_back(t);
            i++;
        }
        p += lstrlen(p)+1;
    }
}

int CCDDrives::getNumDrives()
{
    return m_drives.size();
}

drv_info& CCDDrives::getDrive(int i)
{
    return m_drives[i];
}

CString CCDDrives::getDrivePath(int i)
{
    return m_drives[i].path;
}

CString CCDDrives::getDriveDesc(int i)
{
    return m_drives[i].name;
}


//
// TOC helpers
//

static int MSF2Frames(UCHAR *msf)
{
    return (msf[1]*60+msf[2])*75+msf[3];
}

static void Frames2MSF(UCHAR *msf, int frames)
{
    msf[0] = 0;
    msf[1] = (UCHAR)(frames/(75*60));
    msf[2] = (UCHAR)((frames/75)%60);
    msf[3] = (UCHAR)(frames % 75);
}

static void MSFSub(UCHAR *d, UCHAR *l, UCHAR *r)
{
    Frames2MSF(d, MSF2Frames(l)-MSF2Frames(r));
}

static void MSFAdd(UCHAR *d, UCHAR *l, UCHAR *r)
{
    Frames2MSF(d, MSF2Frames(l)+MSF2Frames(r));
}

static int cddb_sum(int n)
{
	int	ret;

	/* For backward compatibility this algorithm must not change */

	ret = 0;

	while (n > 0) {
		ret = ret + (n % 10);
		n = n / 10;
	}

	return (ret);
}

static DWORD cddb_discid(CDROM_TOC *pToc)
{
	int	i,t=0,n=0;

	/* For backward compatibility this algorithm must not change */

	i = 0;

	while (i<pToc->LastTrack) {
		n = n + cddb_sum((pToc->TrackData[i].Address[1] * 60) + pToc->TrackData[i].Address[2]);
		i++;
	}

	t = ((pToc->TrackData[i].Address[1] * 60) + pToc->TrackData[i].Address[2]) -
	    ((pToc->TrackData[0].Address[1] * 60) + pToc->TrackData[0].Address[2]);

	return ((n % 0xff) << 24 | t << 8 | i);
}


//
// System helpers
//

static MCIDEVICEID OpenMCIDevice(LPCTSTR path)
{
    MCI_OPEN_PARMS mciOpenParms;

    CString mcipath = path;
    mcipath.TrimRight(_T('\\'));

    mciOpenParms.lpstrDeviceType = (LPCTSTR)MCI_DEVTYPE_CD_AUDIO;
    mciOpenParms.lpstrElementName = (LPCTSTR)mcipath;

    if (mciSendCommand(NULL, MCI_OPEN, MCI_OPEN_TYPE|MCI_OPEN_TYPE_ID|MCI_OPEN_ELEMENT|MCI_OPEN_SHAREABLE, (DWORD)&mciOpenParms)) return 0;

    return mciOpenParms.wDeviceID;
}

static BOOL GetMCIMediaID(DWORD *pID, drv_info &drv)
{
    UINT wDeviceID;
    MCI_INFO_PARMS mciInfoParms;
    CHAR info[256];

    wDeviceID = OpenMCIDevice(drv.path);
    if (!wDeviceID) return FALSE;

    mciInfoParms.lpstrReturn = info;
    mciInfoParms.dwRetSize = 255;
    if (mciSendCommand(wDeviceID, MCI_INFO, MCI_INFO_MEDIA_IDENTITY, (DWORD)&mciInfoParms)) {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return FALSE;
    }

    sscanf(mciInfoParms.lpstrReturn, "%d", pID);

    mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
    return TRUE;
}

static BOOL Win9XGetTOC(PCDROM_TOC pToc, drv_info &drv)
{
    // Under Win9x we can't directly get the TOC, so we fake it by getting
    // the track timings and building most of the TOC data from that. It's
    // not a complete TOC - the mode flags are missing for example - but it
    // contains everything this applet cares about. It would probably be
    // possible to fill in the missing data if required.

    UINT wDeviceID;
    DWORD msf;
    MCI_SET_PARMS mciSetParms;
    MCI_STATUS_PARMS mciStatusParms;

    wDeviceID = OpenMCIDevice(drv.path);
    if (!wDeviceID) return FALSE;

    mciSetParms.dwTimeFormat = MCI_FORMAT_MSF;
    
    if (mciSendCommand(wDeviceID, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD)&mciSetParms))  {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return FALSE;
    }

    mciStatusParms.dwItem = MCI_STATUS_NUMBER_OF_TRACKS;
    if (mciSendCommand(wDeviceID, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)(LPVOID) &mciStatusParms)) {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return FALSE;
    }
    int iNumTracks = mciStatusParms.dwReturn;

    pToc->FirstTrack = 1;
    pToc->LastTrack = iNumTracks;

    for ( int i=1 ; i<=iNumTracks ; i++ ) {
        mciStatusParms.dwItem = MCI_STATUS_POSITION;
        mciStatusParms.dwTrack = i;
        if (mciSendCommand(wDeviceID, MCI_STATUS, MCI_STATUS_ITEM| MCI_TRACK, (DWORD)&mciStatusParms)) {
            mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
            return FALSE;
        }

        msf = mciStatusParms.dwReturn;
		pToc->TrackData[i-1].TrackNumber = i;
        pToc->TrackData[i-1].Address[1] = MCI_MSF_MINUTE(msf);
        pToc->TrackData[i-1].Address[2] = MCI_MSF_SECOND(msf);
        pToc->TrackData[i-1].Address[3] = MCI_MSF_FRAME(msf);
    }

    mciStatusParms.dwItem = MCI_STATUS_POSITION;
    mciStatusParms.dwTrack = 0;
    if (mciSendCommand(wDeviceID, MCI_STATUS, MCI_STATUS_ITEM| MCI_STATUS_START, (DWORD)&mciStatusParms)) {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return FALSE;
    }

    msf = mciStatusParms.dwReturn;
	UCHAR startaddr[4];
    startaddr[1] = MCI_MSF_MINUTE(msf);
    startaddr[2] = MCI_MSF_SECOND(msf);
    startaddr[3] = MCI_MSF_FRAME(msf);

    mciStatusParms.dwItem = MCI_STATUS_LENGTH;
    mciStatusParms.dwTrack = 0;
    if (mciSendCommand(wDeviceID, MCI_STATUS, MCI_STATUS_ITEM| MCI_STATUS_LENGTH, (DWORD)&mciStatusParms)) {
        mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
        return FALSE;
    }

    msf = mciStatusParms.dwReturn;
	pToc->TrackData[iNumTracks].TrackNumber = 0xaa;
    pToc->TrackData[iNumTracks].Address[1] = MCI_MSF_MINUTE(msf);
    pToc->TrackData[iNumTracks].Address[2] = MCI_MSF_SECOND(msf);
    pToc->TrackData[iNumTracks].Address[3] = MCI_MSF_FRAME(msf);

    MSFAdd(pToc->TrackData[iNumTracks].Address, pToc->TrackData[iNumTracks].Address, startaddr);

    mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
    return TRUE;
}

static BOOL WinNTGetTOC(PCDROM_TOC pToc, drv_info &drv)
{
    CString drvp;

    drvp.Format(_T("\\\\.\\%s"), (LPCTSTR)drv.path);
    drvp.TrimRight(_T('\\'));

    HANDLE h = CreateFile(drvp, GENERIC_READ, FILE_SHARE_READ|FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
    if (h==INVALID_HANDLE_VALUE) {
        return FALSE;
    }

    DWORD dwRet=0;
    DeviceIoControl(h, IOCTL_CDROM_READ_TOC, NULL, 0, pToc, sizeof(*pToc), &dwRet, NULL);

    CloseHandle(h);
    return TRUE;
}


//
// Information about the current audio CD
//

CCDData::CCDData()
{
    m_valid = false;
}

void CCDData::Refresh(drv_info &drv)
{
    m_valid = false;
    m_dwWin32Serial = 0;
    m_dwMCIID = 0;
    m_cddb = 0;
    memset(&m_toc, 0, sizeof(m_toc));

    m_dwWin32Serial = 0;

    // This call fails for some audio CDs with data tracks. Even if it works it tends
    // to give a bogus value which is quite different from the MCI media id, which is
    // what the Windows CD Player uses to index disks. For a normal audio CD the two
    // numbers are the same

    GetVolumeInformation((LPCTSTR)drv.path, NULL, 0, &m_dwWin32Serial, NULL, NULL, NULL, 0);
//    if (!GetVolumeInformation(path, NULL, 0, &m_dwWin32Serial, NULL, NULL, NULL, 0)) return;

    if (isNT && !WinNTGetTOC(&m_toc, drv)) return;
    if (!isNT && !Win9XGetTOC(&m_toc, drv)) return;

    if (!GetMCIMediaID(&m_dwMCIID, drv)) m_dwMCIID = m_dwWin32Serial;
    m_cddb = cddb_discid(&m_toc);

    m_valid = true;
}

bool CCDData::Eject(drv_info &drv)
{
    UINT wDeviceID;
    MCI_SET_PARMS mciSetParms;

    wDeviceID = OpenMCIDevice(drv.path);
    if (!wDeviceID) return false;

    mciSendCommand(wDeviceID, MCI_SET, MCI_SET_DOOR_OPEN, (DWORD)(LPVOID)&mciSetParms);
    mciSendCommand(wDeviceID, MCI_CLOSE, 0, NULL);
    return true;
}

bool CCDData::isDiskPresent()
{
    return m_valid;
}

DWORD CCDData::getWin32Serial()
{
    return m_dwWin32Serial;
}

DWORD CCDData::getMciId()
{
    return m_dwMCIID;
}

DWORD CCDData::getCDDBDISCID()
{
    return m_cddb;
}

int CCDData::getNumTracks()
{
    return m_toc.LastTrack;
}

int CCDData::getPlayTimeFrames()
{
    return MSF2Frames(m_toc.TrackData[m_toc.LastTrack].Address)-MSF2Frames(m_toc.TrackData[0].Address);
}

void CCDData::getPlayTimeMSF(UCHAR *d)
{
    MSFSub(d, m_toc.TrackData[m_toc.LastTrack].Address, m_toc.TrackData[0].Address);
}

int CCDData::getTrackStartFrames(int i)
{
    return MSF2Frames(m_toc.TrackData[i-1].Address);
}

void CCDData::getTrackStartMSF(UCHAR *d, int i)
{
    memcpy(d, m_toc.TrackData[i-1].Address, 4);
}

int CCDData::getTrackLengthFrames(int i)
{
    return MSF2Frames(m_toc.TrackData[i].Address)-MSF2Frames(m_toc.TrackData[i-1].Address);
}

void CCDData::getTrackLengthMSF(UCHAR *d, int i)
{
    MSFSub(d, m_toc.TrackData[i].Address, m_toc.TrackData[i-1].Address);
}

