// maindlg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINDLG_H__6B293F2E_1946_11D8_9C94_0030BDA0408F__INCLUDED_)
#define AFX_MAINDLG_H__6B293F2E_1946_11D8_9C94_0030BDA0408F__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "cddata.h"


//

class CMainDlg : public CDialogImpl<CMainDlg>, public CUpdateUI<CMainDlg>,
		public CMessageFilter, public CIdleHandler
{
public:
	enum { IDD = IDD_MAINDLG };

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnIdle();

    CCDDrives m_drives;
    CCDData m_data;

	BEGIN_UPDATE_UI_MAP(CMainDlg)
	END_UPDATE_UI_MAP()

	BEGIN_MSG_MAP(CMainDlg)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
        MESSAGE_HANDLER(WM_CTLCOLORSTATIC, OnCtlColorStatic)
        MESSAGE_HANDLER(WM_DRAWITEM, OnDrawItem)
		COMMAND_ID_HANDLER(IDOK, OnOK)
		COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
		COMMAND_ID_HANDLER(IDC_COPY, OnCopy)
		COMMAND_ID_HANDLER(IDC_EJECT, OnEject)
	END_MSG_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	void Clear()
	{
		SetDlgItemText(IDC_EDIT1, _T(""));
	}

	int Output(LPTSTR fmt, ...)
	{
		va_list args;
		va_start(args, fmt);

		TCHAR buf[1024];
		int rv = _vsntprintf(buf, 1024, fmt, args);

		CString t;
		int tl = ::GetWindowTextLength(GetDlgItem(IDC_EDIT1));
		GetDlgItemText(IDC_EDIT1, t.GetBuffer(tl+1), tl+1);
		t.ReleaseBuffer();

		t += buf;
		SetDlgItemText(IDC_EDIT1, t);

		va_end(args);
		return rv;
	}

    LRESULT OnCtlColorStatic(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        HDC hdc = (HDC)wParam;
        HWND hwnd = (HWND)lParam;

        if (hwnd==GetDlgItem(IDC_EDIT1)) {
            // SetBkColor(hdc, GetSysColor(COLOR_WINDOW);
            return (LRESULT)GetSysColorBrush(COLOR_WINDOW);
        }

        bHandled = FALSE;
        return 0;
    }

    void SetBusy(bool busy);
    bool m_busy;
    HBRUSH m_hbrRed;
    HBRUSH m_hbrGreen;

	LRESULT OnDrawItem(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
    {
        UINT idCtl = (UINT)wParam;
        LPDRAWITEMSTRUCT lpdis = (LPDRAWITEMSTRUCT)lParam;

        if (idCtl!=IDC_STATIC_STATUS) {
            bHandled = FALSE;
            return FALSE;
        }

//        RECT rc;
//        ::GetClientRect(lpdis->hwndItem, &rc);
        FillRect(lpdis->hDC, &lpdis->rcItem, m_busy ? m_hbrRed : m_hbrGreen);

        return TRUE;
    }

	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCopy(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnEject(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);

	void CloseDialog(int nVal);
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINDLG_H__6B293F2E_1946_11D8_9C94_0030BDA0408F__INCLUDED_)
